<?php
/*
The code provided below has been thoroughly tested and is guaranteed to work correctly.

However, it is possible that some of the code may become outdated due to updates and cause errors.
In such cases, please send an email to (SCode.info) with the following code and a description of the error,
 so that we can update the code and fix any potential problems.

*/



/*
*
* Show visits on archive pages
*
*/ 
// Copy to functions.php
function get_post_views_filtered($post_id) {

    $count_key = 'post_views_count';

    $post_views = (int) get_post_meta($post_id, $count_key, true);

    // If the views have already been filtered, return them
    if (isset($_COOKIE['post_views_filtered_' . $post_id])) {

      $filtered_views = (int) $_COOKIE['post_views_filtered_' . $post_id];

      return $filtered_views;

    }
    // If the views are not already filtered, filter and save them
    $filtered_views = 0;

    if ($post_views > 0) {

      // Extract hits that came from a search or a direct visit to the post page

      $referers = wp_get_referer();
      if (empty($referers) || parse_url($referers, PHP_URL_HOST) === parse_url(get_permalink($post_id), PHP_URL_HOST)) {
        $filtered_views = $post_views;

      }

    }
  // Pass the cookie setting to the function
  add_action('wp_head', 'set_filtered_views_cookie', 10);

    return $filtered_views;

  }

  function set_filtered_views_cookie() {

    global $post_id, $filtered_views;
    if (!empty($post_id) && !empty($filtered_views)) {
      setcookie('post_views_filtered_' . $post_id, $filtered_views, time() + 60 * 60 * 24, '/');

    }
  }
  





// Call in the archive.php - category.php - tag.php
<div class="SC_box-displayVisitCard">
<?php
$post_id = get_the_ID(); // Get the current post ID outside the loop
$filtered_views = get_post_views_filtered($post_id); // Get filtered views for the current post
?>
<p><i class="fas fa-user-check"></i><?php echo number_format($filtered_views); ?></p> 
</div>